function EF_Flash()
---------------- flash
  em_life(0.3);
  em_color(1,1,1);
  em_alpha(0.8, 0, 0);
  em_size(0.003, 0.5)
  em_vel(0);
  em_theta(360);
  em_gravity(0);
  em_tex(8);
  em_shadow(0);
  EmitSphere(1, 0.001);
end


function EF_BallExplosion(r,g,b)
  ---------------- smoke
  em_life(1.2);
  em_color(r,g,b);
  em_alpha(0.8, 0, 0.2);
  em_size(0.08, 0.20)
  em_vel(0.07);
  em_theta(120);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitBox(2);
  ------------------ sparks
  em_life(0.8);
  em_color(r,g,b);
  em_alpha(1, 0, 0.2);
  em_size(0.01, 0.01, 0.01)
  em_vel(0.5, 0.2);
  em_theta(120);
  em_gravity(-0.9);
  em_tex(7);
  em_shadow(0);
  EmitBox(5);
end


function EF_EndGate()	
  ---------------- smoke
  em_life(1.0);
  em_color(0.9, 0.9, 0.9);
  em_alpha(0.5, 0, 0.2);
  em_size(0.1, 0.2)
  em_vel(0.2);
  em_theta(100);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitBox(1);
end


function EF_Snow()	
  em_life(100.0);
  em_color(0.6, 0.6, 0.9);
  em_alpha(0.9, 0.9, 0.1);
  em_size(0.01, 0.01)
  em_vel(-0.2);
  em_theta(1);
  em_gravity(0);
  em_tex(7);
  em_shadow(0);
  EmitPlain(3,4);
end



function EF_LevelDotFlash_2d()	
  ---------------- flash
  r=1;
  g=1;
  b=1;
  em_life(0.5);
  em_color(r,g,b);
  em_alpha(0.99, 0, 0);
  em_size(40, 5, 0)
  em_vel(0);
  em_theta(360);
  em_gravity(0);
  em_tex(3);
  em_shadow(0);
  EmitSphere_2d(2,10);
  ------------------ sparks
  em_life(0.8);
  em_color(r,g,b);
  em_alpha(1, 0, 0.2);
  em_size(10, 1, 0.01)
  em_vel(60, 0);
  em_theta(360);
  em_gravity(0);
  em_tex(7);
  em_shadow(0);
  EmitSphere_2d(20,10);
end

function EF_MapPathFlash_2d()	
  ---------------- flash
  r=1.0;
  g=0.6;
  b=0.6;
  em_life(2.5);
  em_color(r,g,b);
  em_alpha(0.99, 0, 0);
  em_size(20, 5,0)
  em_vel(0);
  em_theta(360);
  em_gravity(0);
  em_tex(3);
  em_shadow(0);
  EmitSphere_2d(2,10);
  ------------------ sparks
  em_life(0.3);
  em_color(r,g,b);
  em_alpha(1, 0, 0.2);
  em_size(4, 1, 0.01)
  em_vel(70, 0);
  em_theta(360);
  em_gravity(0);
  em_tex(3);
  em_shadow(0);
  EmitSphere_2d(4,1);
end


function EF_SelectedStageFlash_2d()	
  ---------------- flash
  r=0.4;
  g=0.4;
  b=1;
  em_life(2);
  em_color(r,g,b);
  em_alpha(0.0, 0.9, 0);
  em_size(100, 1, 0)
  em_vel(0);
  em_theta(360);
  em_gravity(0);
  em_tex(4);
  em_shadow(0);
  EmitSphere_2d(1,0);
  ------------------ sparks
  em_life(2.5);
  em_color(r,g,b);
  em_alpha(1, 0.5, 0.2);
  em_size(7, 1, 0.01)
  em_vel(10, 20);
  em_theta(360);
  em_gravity(0);
  em_tex(8);
  em_shadow(0);
  EmitSphere_2d(30,0);
end


function EF_FireballRun()	
  ---------------- smoke
  em_life(0.8);
  em_color(1, 1, 1);
  em_alpha(0.7, 0, 0.2);
  em_size(0.07, 0.12)
  em_vel(0.2);
  em_theta(300);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitSphere(1, 0.05);
end

function EF_FireballFly()	
  ---------------- smoke
  em_life(0.5);
  em_color(1, 1, 1);
  em_alpha(0.7, 0, 0.2);
  em_size(0.07, 0.2)
  em_vel(0.2);
  em_theta(300);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitSphere(1, 0.01);
end


function EF_FireballFlash()	
  em_life(0.3);
  em_color(1,1,1);
  em_alpha(0.8, 0, 0);
  em_size(0.003, 2)
  em_vel(0);
  em_theta(360);
  em_gravity(0);
  em_tex(8);
  em_shadow(0);
  EmitSphere(1, 0.001);
end

function EF_FireballExplode(r)	
  em_life(0.1);
  em_color(1, 1, 1);
  em_alpha(0.7, 0, 0.2);
  em_size(r, r)
  em_vel(0.2);
  em_theta(300);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitSphere(1, 0);
end

function EF_BallExplosionFireball()
  ---------------- smoke
  em_life(0.7);
  em_color(1,0.7,0.7);
  em_alpha(0.8, 0, 0.2);
  em_size(0.15, 0.30)
  em_vel(0.2);
  em_theta(120);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitSphere(2,0.1);
end

function EF_BallExplosionIce()
  ---------------- smoke
  em_life(0.7);
  em_color(0.5,0.5,1);
  em_alpha(0.8, 0, 0.2);
  em_size(0.15, 0.30)
  em_vel(0.2);
  em_theta(120);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitSphere(2,0.1);
end


function EF_IceRun()	
  ---------------- smoke
  em_life(0.2);
  em_color(0.1, 0.1, 1);
  em_alpha(0.9, 0, 0.1);
  --em_size(0.07, 0.2)
  em_size(0.15, 0.3)
  em_vel(0.2);
  em_theta(300);
  em_gravity(0.1);
  em_tex(7);
  em_shadow(0);
  EmitSphere(1, 0.01);


 ------------------ sparks
  em_life(0.8);
  em_color(1,1,1);
  em_alpha(1, 0, 0.2);
  em_size(0.01, 0.01, 0.01)
  em_vel(0.5, 0.2);
  em_theta(120);
  em_gravity(-0.9);
  em_tex(7);
  em_shadow(0);
  EmitSphere(1, 0.01);

end


function EF_RockFly()	
  em_life(0.1);
  --em_color(1, 1, 1);
  em_color(0.9, 0.8, 1);
  em_alpha(0.5, 0, 0.2);
  em_size(0.02, 0.07)
  em_vel(0.9, 0.1);
  em_theta(300);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitSphere(1, 0.01);
end


function EF_FillbarFlash_2d()	
  ---------------- flash
  r=1;
  g=1;
  b=1;
  em_life(0.5);
  em_color(r,g,b);
  em_alpha(0.99, 0, 0);
  em_size(40, 5, 0)
  em_vel(0);
  em_theta(360);
  em_gravity(0);
  em_tex(3);
  em_shadow(0);
  EmitSphere_2d(2,10);
  ------------------ sparks
  em_life(0.8);
  em_color(r,g,b);
  em_alpha(1, 0, 0.2);
  em_size(5, 1, 0.01)
  em_vel(30, 0);
  em_theta(160);
  em_gravity(-5);
  em_tex(7);
  em_shadow(0);
  EmitSphere_2d(5,10);
end


function EF_BonusGem()	
  em_life(0.9);
  em_color(1,1,1);
  em_alpha(0.7, 0, 0.2);
  em_size(0.04, 0.01, 0.01)
  em_vel(0.1, 0.1);
  em_theta(12);
  em_gravity(0.3);
  em_tex(0);
  em_shadow(0);
  EmitSphere(1, 0.1);
end


function EF_ShopButtonShine_2d()
  r=1;
  g=1;
  b=1;
 ------------------ sparks
  em_life(0.5);
  em_color(r,g,b);
  em_alpha(0.0, 1.0, 0.0);
  em_size(10, 1, 0.01)
  em_vel(2, 0);
  em_theta(360);
  em_gravity(0);
  em_tex(7);
  em_shadow(0);
  EmitSphere_2d(1,20);
end

function EF_LevelComplete3()
   r=1;
  g=1;
  b=1;
  em_life(0.5);
  em_color(1,0.7,0.7);
  em_alpha(0.8, 0, 0.2);
  em_size(0.1, 0.001)
  em_vel(0.1);
  em_theta(120);
  em_gravity(0.1);
  em_tex(7);
  em_shadow(0);
  EmitSphere(9,0.1);

  em_life(0.7);
  em_color(1,0.7,0.7);
  em_alpha(0.8, 0, 0.2);
  em_size(0.15, 0.30)
  em_vel(0.2);
  em_theta(120);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitSphere(2,0.1);
end

function EF_LevelComplete()
  r=1;
  g=1;
  b=1;
  em_life(0.5);
  em_color(1,0.7,0.7);
  em_alpha(0.9, 0, 0.1);
  em_size(0.1, 0.001)
  em_vel(0.9);
  em_theta(120);
  em_gravity(0.1);
  em_tex(7);
  em_shadow(0);
  EmitSphere(9,0.1);
end

function EF_Warning()
  r=1;
  g=1;
  b=1;
  em_life(0.5);
  em_color(1,0.7,0.7);
  em_alpha(0.9, 0, 0.1);
  em_size(0.1, 0.001)
  em_vel(0.1);
  em_theta(120);
  em_gravity(0.1);
  em_tex(7);
  em_shadow(0);
  EmitSphere(4,0.05);
end

function EF_ShopSmoke_2d()
  ---------------- smoke
  em_life(10);
  em_color(0.5,0.5,1);
  em_alpha(0.1, 0.0, 0.1);
  em_size(0, 50)
  em_vel(5);
  em_theta(360);
  em_gravity(0.1);
  em_tex(1);
  em_shadow(0);
  EmitSphere_2d(1,20);
end



function EF_Fireworks_2d()	
  ---------------- flash
  r=1;
  g=1;
  b=1;
  em_life(0.5);
  em_color(r,g,b);
  em_alpha(0.99, 0, 0);
  em_size(40, 5, 0)
  em_vel(0);
  em_theta(360);
  em_gravity(0);
  em_tex(3);
  em_shadow(0);
  EmitSphere_2d(2,10);
  ------------------ sparks
  em_life(0.9);
  em_color(r,g,b);
  em_alpha(1, 0, 0.2);
  em_size(10, 1, 0.01)
  em_vel(70, 0);
  em_theta(360);
  em_gravity(0);
  em_tex(7);
  em_shadow(0);
  EmitSphere_2d(20,10);
end

function EF_TowerRising_2d()	
  r=1;
  g=1;
  b=1;
 ------------------ sparks
  em_life(0.3);
  em_color(r,g,b);
  em_alpha(0.0, 1.0, 0.0);
  em_size(10, 1, 0.01)
  em_vel(2, 0);
  em_theta(360);
  em_gravity(0);
  em_tex(2);
  em_shadow(0);
  EmitSphere_2d(2,30);

 ------------------ smoke
  em_life(0.9);
  em_color(1,0.5,1);
  em_alpha(1.0, 0.0, 0.0);
  em_size(1, 30, 0.01)
  em_vel(5, 0);
  em_theta(360);
  em_gravity(0);
  em_tex(3);
  em_shadow(0);
  EmitSphere_2d(1,30);

end


function EF_TowerBall_2d()	
 
 ------------------ smoke
  em_life(1.4);
  em_color(1,0.7,1);
  em_alpha(0.5, 0.0, 0.0);
  em_size(15, 1, 1)
  em_vel(1, 0);
  em_theta(360);
  em_gravity(-30);
  em_tex(1);
  em_shadow(0);
  EmitSphere_2d(1,2);

end